{include file="content-frame-top.tpl"
         header="##LG_HIGH_AVAILABILITY## :: ##LG_SERVER_STATUS##"}


<table class="iw-w-full">
  <tr>
  {foreach item=server from=$iw_servers}

    {if $server.ha.status != 'online'}
      {assign var="offline_class" value="iw-error-row"}
    {else}
      {assign var="offline_class" value=""}
    {/if}

    <td class="iw-w-xl">
      <h1>{$server.hostname} ( {$server.internal_ip} )</h1>

      <table class="iw-table iw-w-full">

        {if $server.sysinfo ne false}
        <tr class="{cycle}">
          <td>##LG_ROLE##</td>
          <td>{$server.role}</td>
        </tr>
        {/if}

        <tr class="{cycle}">
          <td class="{$offline_class}">Status</td>
          <td class="{$offline_class}">
          {if $server.sysinfo ne false && $server.ha.status eq 'OFFLINE' }
            ##LG_PACEMAKER_DISABLED##
          {else}
            {$server.ha.status}
          {/if}
          </td>
        </tr>

        {if $server.sysinfo ne false}
        <tr class="{cycle}">
          <td>##LG_DISTRIBUTION##</td>
          <td>{$server.sysinfo.distro}</td>
        </tr>

        <tr class="{cycle}">
          <td>##LG_OPSYSTEM##</td>
          <td>{$server.sysinfo.kernel}</td>
        </tr>

        <tr class="{cycle}">
          <td>##LG_CPU##</td>
          <td>{$server.sysinfo.cpu.model}</td>
        </tr>

        <tr class="{cycle}">
          <td>##LG_SYSTEMMEMORY##</td>
          <td>
            {math equation="x / 1024" x=$server.sysinfo.memory.ram.total format="%.2f"} ##LG_MB##
          </td>
        </tr>

        <tr class="{cycle}">
          <td>##LG_UPTIME##</td>
          <td>{$server.sysinfo.uptime}</td>
        </tr>

        <tr class="{cycle}">
          <td>##LG_LOADAVERAGE##</td>
          <td>
            {$server.sysinfo.loadavg.0}
            {$server.sysinfo.loadavg.1}
            {$server.sysinfo.loadavg.2}
         </td>
        </tr>
        {/if}
      </table>

      <h1> ##LG_STORAGE_SYNC_STATUS## </h1>
      <table class="iw-table iw-w-full">
        <tr class="iw-table-hd">
          <td>##LG_NAME##</td>
          <td>##LG_CONNECTION_STATUS##</td>
          <td>##LG_ROLE##</td>
          <td>##LG_DISK_STATES##</td>
        </tr>

        {foreach item=drbd from=$server.drbd}
        <tr class="{cycle} ruler">
          <td class="{$offline_class} center">{$drbd.na}</td>
          <td class="{$offline_class} center">{$drbd.cs}</td>
          <td class="{$offline_class} center">{$drbd.ro}</td>
          <td class="{$offline_class} center">{$drbd.ds}</td>
        </tr>
        {foreachelse}
        <tr class="{cycle} ruler">
          <td colspan="4">
            {iw_message_block mode='negative'}
              ##LG_NO_DRBD_RESOURCES_CONFIGURED##
            {/iw_message_block}
          </td>
        </tr>
        {/foreach}
      </table>

      <h1> ##LG_FAILOVER_RESOURCES## </h1>
      <table class="iw-table iw-w-full">
        <tr class="iw-table-hd">
          <td class="iw-w-tight">&nbsp;</td>
          <td class="left">##LG_NAME##</td>
          <td>##LG_RESOURCE##</td>
          <td class="iw-w-l">##LG_STATUS##</td>
        </tr>

        {foreach item=primitive from=$server.ha.primitives}
        <tr class="{cycle} ruler">
          <td> {* {iw_quickhelp id=$primitive.qh} *} </td>
          <td class="left">{$primitive.name}</td>
          <td class="center">{$primitive.agent}</td>
          <td class="center">{$primitive.status}</td>
        </tr>
        {foreachelse}
        <tr class="{cycle} rules">
          <td colspan="4">
            {iw_message_block mode='negative'}
              ##LG_NO_FAILOVER_RESOURCES_CONFIGURED##
            {/iw_message_block}
          </td>
        </tr>
        {/foreach}
      </table>


    </td>
  {/foreach}
  </tr>
</table>

{include file="content-frame-bottom.tpl"}
